//
//  AppDelegate.m
//  CCClassRoom
//
//  Created by cc on 17/1/18.
//  Copyright © 2017年 cc. All rights reserved.
//

#import "AppDelegate.h"
#import <SDImageCache.h>
#import "SULogger.h"
#import "CCExceptionHandler.h"
//#import <Bugly/Bugly.h>
#import <OpenGLES/ES2/gl.h>
#import <CCClassRoom/CCClassRoom.h>
#import <CCClassRoomBasic/CCClassRoomBasic.h>
#import "CCTool.h"

@interface AppDelegate ()

@end

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    [[UIApplication sharedApplication] setStatusBarHidden:NO];
    [SDImageCache sharedImageCache].shouldDecompressImages = NO;
    //    [SULogger start];
//    BuglyConfig *config = [[BuglyConfig alloc] init];
//    config.debugMode = true;
//    config.viewControllerTrackingEnable = true;
//
//    config.reportLogLevel = BuglyLogLevelWarn;
//    [Bugly startWithAppId:@"70f4bb406e" config:config];

    [CCStreamerBasic startListen:YES];
//    [CCStreamerBasic setLogState:YES];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//        [self crashTest];
    });
    return YES;
}

- (void)crashTest
{
    NSMutableArray *arr = [NSMutableArray arrayWithCapacity:2];
    
    [arr removeObjectAtIndex:3];
} 

- (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(nullable UIWindow *)window
{
    if (self.shouldNeedLandscape)
    {
        return UIInterfaceOrientationMaskLandscapeRight;
    }
    else
    {
        return UIInterfaceOrientationMaskPortrait;
    }
}

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url {
    if (!url) {
        return NO;
    }
    NSString *urlStr = [url absoluteString];
    NSLog(@" schemeApp %@",urlStr);
    
    [self scheme:urlStr];
    
    return YES;
}

- (void)scheme:(NSString *)urlStr {
    NSLog(@"schemeApp  ");
    UINavigationController *_NAV = (UINavigationController *)(self.window.rootViewController);

    NSMutableArray * navArray = [_NAV.viewControllers mutableCopy];
    for (UIViewController *vc in navArray) {
        if ([vc isKindOfClass:NSClassFromString(@"CCLoginViewController")]) {
            [_NAV popToRootViewControllerAnimated:YES];
            break;
        }
    }
    
    if ([urlStr containsString:@"csslcloud://minclass?"] || [urlStr containsString:@"csslcloud://"]) {
        NSRange range = [urlStr rangeOfString:@"?"];
        if (range.length == 0) {
            urlStr = [urlStr stringByReplacingOccurrencesOfString:@"csslcloud://miniclass?" withString:@""];
        } else {
            urlStr = [urlStr substringFromIndex:(range.location + 1)];
        }
    }
    NSString *roomid = @"";NSString *userID = @"";NSString *role = @"";NSString *domain = @"";
    NSArray *arr = [urlStr componentsSeparatedByString:@"&"];
    for (NSString *name in arr) {
        if ([name containsString:@"roomid"]) {
            roomid = [name stringByReplacingOccurrencesOfString:@"roomid=" withString:@""];
            
        } else if ([name containsString:@"userid"]) {
            userID = [name stringByReplacingOccurrencesOfString:@"userid=" withString:@""];
            
        } else if ([name containsString:@"role"]) {
            role = [name stringByReplacingOccurrencesOfString:@"role=" withString:@""];
        } else if ([name containsString:@"domain"]) {
            domain = [name stringByReplacingOccurrencesOfString:@"domain=" withString:@""];
        }
    }
    [self appToRoomId:roomid role:role userId:userID domain:domain];
}

- (void)appToRoomId:(NSString *)roomId role:(NSString *)role userId:(NSString *)userId domain:(NSString *)domain {
    
    if (domain.length == 0 ) {
        [[CCStreamer sharedStreamer]setServerDomain:@"class.csslcloud.net" area:nil];

    } else {
        [[CCStreamer sharedStreamer]setServerDomain:domain area:nil];
    }
    
    if (roomId.length == 0 || role.length == 0 || userId.length == 0 || domain.length == 0) {
        CCLog(@"数据有问题");
        return;
    }
    
    [[CCStreamer sharedStreamer] getRoomDescWithRoonID:roomId completion:^(BOOL result, NSError *error, id info) {
        CCLog(@"%s__%d__%@__%@__%@", __func__, __LINE__, @(result), error, info);
        if (result)
        {
            NSString *result = info[@"result"];
            if ([result isEqualToString:@"OK"])
            {
                UINavigationController *_NAV = (UINavigationController *)(self.window.rootViewController);

                NSString *name = info[@"data"][@"name"];
                NSString *desc = info[@"data"][@"desc"];
                NSString *authKey = [CCTool authTypeKeyForRole:role];

                SaveToUserDefaults(LIVE_ROOMNAME, name);
                SaveToUserDefaults(LIVE_ROOMDESC, desc);
                NSDictionary *userInfo = @{@"userID":userId, @"roomID":roomId, @"role":role, @"authtype":info[@"data"][authKey]};
                [_NAV popViewControllerAnimated:NO];

                [[NSNotificationCenter defaultCenter] postNotificationName:@"ScanSuccess" object:nil userInfo:userInfo];

            }
            else
            {
                UINavigationController *_NAV = (UINavigationController *)(self.window.rootViewController);

                [_NAV popViewControllerAnimated:NO];
            }
        }
        else
        {
//            [UIAlertView bk_showAlertViewWithTitle:@"注意" message:error.localizedDescription cancelButtonTitle:@"知道了" otherButtonTitles:nil handler:^(UIAlertView *alertView, NSInteger buttonIndex) {
//                [ws.navigationController popViewControllerAnimated:YES];
//            }];
        }
    }];
}


- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    glFinish();
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    [[UIApplication sharedApplication] setStatusBarHidden:NO];
    // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    //    [[UIApplication sharedApplication] setStatusBarHidden:NO];
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}


- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}


@end
