//
//  CCDocViewController.m
//  CCClassRoom
//
//  Created by cc on 17/3/30.
//  Copyright © 2017年 cc. All rights reserved.
//

#import "CCDocViewController.h"
#import <Masonry.h>
#import <CCClassRoom/CCClassRoom.h>
#import "CCDocManager.h"
#import "CCDrawMenuView.h"
#import "LoadingView.h"
#import "CCStreamModeTeach_Teacher.h"
#import "CCDoc.h"

#define infomationViewClassRoomIconLeft 3
#define infomationViewErrorwRight 9.f
#define infomationViewHandupImageViewRight 16.f
#define infomationViewHostNamelabelLeft  13.f
#define infomationViewHostNamelabelRight 0.f

@interface CCDocViewController ()<CCDrawMenuViewDelegate>
@property (strong, nonatomic) UIButton *fullBtn;
@property(nonatomic,strong)CCDrawMenuView *drawMenuView;
@property(nonatomic,strong)LoadingView *loadingView;

#pragma mark -- 计时器
@property(nonatomic,strong)UIView *timerView;
@property(nonatomic,strong)UILabel *timerLabel;
@property(nonatomic,strong)NSTimer *timerTimer;
@end

@implementation CCDocViewController
- (id)initWithDocView:(UIView *)view streamView:(CCStreamerView *)streamView
{
    if (self = [super init])
    {
        self.docView = view;
        self.streamView = streamView;
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    WS(ws);
    NSNumber *orientationTarget = [NSNumber numberWithInt:UIInterfaceOrientationLandscapeRight];
    [[UIDevice currentDevice] setValue:orientationTarget forKey:@"orientation"];
    
    __weak typeof(self) weakSelf = self;
    [self.view addSubview:self.docView];
    [self.docView mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.edges.mas_equalTo(weakSelf.view).offset(0.f);
    }];
    
    [self.view addSubview:self.timerView];
    [self.timerView mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(ws.view).offset(10.f);
        make.top.mas_equalTo(ws.view).offset(CCGetRealFromPt(60) + [CCTool tool_MainWindowSafeArea_Top]);
        make.height.mas_equalTo(1);
        make.width.mas_equalTo(1);
    }];
    
    
    CGFloat width = MAX([UIScreen mainScreen].bounds.size.width, [UIScreen mainScreen].bounds.size.height);
    CGFloat height = MIN([UIScreen mainScreen].bounds.size.width, [UIScreen mainScreen].bounds.size.height);
    [[CCDocManager sharedManager] changeDocParentViewFrame:CGRectMake(0, 0, width, height)];
    self.fullBtn = [UIButton new];
    [self.fullBtn setTitle:@"" forState:UIControlStateNormal];
    [self.fullBtn setImage:[UIImage imageNamed:@"exitfullscreen"] forState:UIControlStateNormal];
    [self.fullBtn setImage:[UIImage imageNamed:@"exitfullscreen_touch"] forState:UIControlStateSelected];
    [self.fullBtn addTarget:self action:@selector(clickFull) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:self.fullBtn];
    [self.fullBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(weakSelf.docView.mas_right).offset(-CCGetRealFromPt(30));
        make.bottom.mas_equalTo(weakSelf.docView.mas_bottom).offset(-10.f);
    }];
    
    NSString *userID = [CCStreamer sharedStreamer].getRoomInfo.user_id;
    NSLog(@"%s__%@", __func__, userID);
    for (CCUser *user in [CCStreamer sharedStreamer].getRoomInfo.room_userList)
    {
        CCLog(@"%s__%d__%@__%@", __func__, __LINE__, user.user_id, @(user.user_drawState));
        if ([user.user_id isEqualToString:userID])
        {
            if (user.user_AssistantState || user.user_drawState || user.user_role == CCRole_Teacher || user.user_role == CCRole_Assistant)
            {
                [self drawMenuView1];
                [[CCDocManager sharedManager] showOrHideDrawView:NO];
            }
        }
    }
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    
    NSNumber *orientationTarget = [NSNumber numberWithInt:UIInterfaceOrientationPortrait];
    [[UIDevice currentDevice] setValue:orientationTarget forKey:@"orientation"];
    
    NSString *userID = [CCStreamer sharedStreamer].getRoomInfo.user_id;
    for (CCUser *user in [CCStreamer sharedStreamer].getRoomInfo.room_userList)
    {
        if ([user.user_id isEqualToString:userID])
        {
            if (user.user_AssistantState || user.user_drawState || user.user_role == CCRole_Teacher || user.user_role == CCRole_Assistant)
            {
                [[CCDocManager sharedManager] showOrHideDrawView:YES];
            }
        }
    }
    [self stopTimeTimer];
}

- (void)clickFull
{
    [[NSNotificationCenter defaultCenter] postNotificationName:CCNotiDocViewControllerClickSamll object:nil userInfo:@{}];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//- (BOOL)shouldAutorotate{
//    return NO;
//}
//
//- (BOOL) shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation
//{
//    bool bRet = ((toInterfaceOrientation == UIInterfaceOrientationLandscapeRight) || (toInterfaceOrientation == UIInterfaceOrientationLandscapeLeft));
//    return bRet;
//}
//
//- (UIInterfaceOrientationMask)supportedInterfaceOrientations
//{
//    return UIInterfaceOrientationMaskLandscapeRight|UIInterfaceOrientationMaskLandscapeLeft;
//}

- (CCDrawMenuView *)drawMenuView1
{
    if (_drawMenuView)
    {
        _drawMenuView.delegate = nil;
        [_drawMenuView removeFromSuperview];
        _drawMenuView = nil;
    }
    if (!_drawMenuView)
    {
        CCRole role = [CCStreamer sharedStreamer].getRoomInfo.user_role;
        NSString *userID = [CCStreamer sharedStreamer].getRoomInfo.user_id;
        CCUser *user = [[CCStreamer sharedStreamer] getUSerInfoWithUserID:userID];
        if (role == CCRole_Teacher || role == CCRole_Assistant)
        {
            BOOL isWhite = YES;
            NSString *imageUrl = [CCDocManager sharedManager].ppturl;
            if ([imageUrl hasPrefix:@"#"] || [imageUrl hasSuffix:@"#"])
            {
                isWhite = YES;
            }
            else
            {
                isWhite = NO;
            }
            if (isWhite)
            {
                //TODO..Modify...20190404..增加 CCDragStyle_Page
                //之前白板不显示前后翻页页码，为了修改bug-2902 添加了页码显示
                _drawMenuView = [[CCDrawMenuView alloc] initWithStyle:CCDragStyle_DrawAndBack|CCDragStyle_Clean|CCDragStyle_Page];
            }
            else
            {
                _drawMenuView = [[CCDrawMenuView alloc] initWithStyle:CCDragStyle_DrawAndBack|CCDragStyle_Clean|CCDragStyle_Page];
            }
        }
        else
        {
            //            _drawMenuView = [[CCDrawMenuView alloc] initWithStyle:CCDragStyle_DrawAndBack];
            if ((user.user_AssistantState || user.user_drawState))
            {
                if (user.user_AssistantState)
                {
                    CCDocManager* docManager = [CCDocManager sharedManager];
                    NSString *imageUrl = docManager.ppturl;
                    //Chenfy..modify..添加了WhiteBoard字段的判断
                    if (([imageUrl hasPrefix:@"#"] || [imageUrl hasSuffix:@"#"])&&[docManager.docId isEqualToString:@"WhiteBoard"])
                    {
                        _drawMenuView = [[CCDrawMenuView alloc] initWithStyle:CCDragStyle_DrawAndBack|CCDragStyle_Clean];
                    }
                    else
                    {
                        _drawMenuView = [[CCDrawMenuView alloc] initWithStyle:CCDragStyle_DrawAndBack|CCDragStyle_Clean|CCDragStyle_Page];
                    }
                }
                else if(user.user_drawState)
                {
                    _drawMenuView = [[CCDrawMenuView alloc] initWithStyle:CCDragStyle_DrawAndBack];
                }
            }
        }
        _drawMenuView.delegate = self;
        [self pageResetPageShow];
        
        [self.view addSubview:_drawMenuView];
        __weak typeof(self) weakSelf = self;
        [_drawMenuView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.mas_equalTo(weakSelf.view).offset(20.f);
            make.centerX.mas_equalTo(weakSelf.view);
        }];
    }
    return _drawMenuView;
}
//计算page显示的标题
- (void)pageResetPageShow
{
    CCDoc *doc = self.streamView.steamSpeak.nowDoc;
    int pageNow = 1 , pageTotal = 1;
    if (doc)
    {
        //计算page显示
        pageNow = (int)(self.streamView.steamSpeak.nowDocpage+1);
        pageNow = pageNow < 1 ? 1 :pageNow;
        pageTotal = (int) (self.streamView.steamSpeak.nowDoc.pageSize);
    }
    pageTotal = pageTotal < 1 ? 1 : pageTotal;
    if (doc.size == 0)
    {
        pageNow = 1;
    }
    NSString *textPN = [NSString stringWithFormat:@"%d / %d", pageNow, pageTotal];
    CCLog(@"PN______:< %@ >__%s____< %d >___",textPN,__func__,__LINE__);
    _drawMenuView.pageLabel.text = textPN;
}
- (BOOL)isWhiteBoard
{
    BOOL isWhite = YES;
    NSString *imageUrl = [CCDocManager sharedManager].ppturl;
    if ([imageUrl hasPrefix:@"#"] || [imageUrl hasSuffix:@"#"])
    {
        isWhite = YES;
    }
    else
    {
        isWhite = NO;
    }
    return isWhite;
}

- (void)drawBtnClicked:(UIButton *)btn
{
    
}

- (void)frontBtnClicked:(UIButton *)btn
{
    //撤销
    [[CCDocManager sharedManager] revokeDrawData];
}

- (void)menuBtnClicked:(UIButton *)btn
{
    //显示操作栏
    //    [self.streamView hideOrShowView:YES];
}

- (void)cleanBtnClicked:(UIButton *)btn
{
    [[CCDocManager sharedManager] cleanDrawData];
}

- (void)pageFrontBtnClicked:(UIButton *)btn
{
    if ([self isWhiteBoard])
    {
        return;
    }
    [self.streamView clickFront:nil];
    NSString *textPN =  [NSString stringWithFormat:@"%@ / %@", @(self.streamView.steamSpeak.nowDocpage+1), @(self.streamView.steamSpeak.nowDoc.pageSize)];
    CCLog(@"PN______:< %@ >__%s____< %d >___",textPN,__func__,__LINE__);
    self.drawMenuView.pageLabel.text = textPN;
}

- (void)pageBackBtnClicked:(UIButton *)btn
{
    if ([self isWhiteBoard])
    {
        return;
    }
    [self.streamView clickBack:nil];
    NSInteger nowPage = self.streamView.steamSpeak.nowDocpage+1;
    NSString *textPN = [NSString stringWithFormat:@"%@ / %@", @(nowPage), @(self.streamView.steamSpeak.nowDoc.pageSize)];
    CCLog(@"PN______:< %@ >__%s____< %d >___",textPN,__func__,__LINE__);
    self.drawMenuView.pageLabel.text = textPN;
}

- (void)docPageChange
{
    NSString *textPN = [NSString stringWithFormat:@"%@ / %@", @(self.streamView.steamSpeak.nowDocpage+1), @(self.streamView.steamSpeak.nowDoc.pageSize)];
    CCLog(@"PN______:< %@ >__%s____< %d >___",textPN,__func__,__LINE__);
    self.drawMenuView.pageLabel.text = textPN;
}

- (void)showOrHideDrawView:(BOOL)show calledByDraw:(BOOL)calledByDraw
{
    if (show)
    {
        NSString *title = calledByDraw ? @"您已被老师开启授权标注" : @"您已被老师开启设为讲师";
        [self showAutoHiddenAlert:title];
        [self drawMenuView1];
        [[CCDocManager sharedManager] showOrHideDrawView:NO];
    }
    else
    {
        NSString *title = calledByDraw ? @"您已被老师关闭授权标注" : @"您已被老师关闭设为讲师";
        
        NSString *userID = [[CCStreamer sharedStreamer] getRoomInfo].user_id;
        CCUser *user = [[CCStreamer sharedStreamer] getUSerInfoWithUserID:userID];
        if (user.user_drawState || user.user_AssistantState)
        {
            [self drawMenuView1];
        }
        else
        {
            [[CCDocManager sharedManager] showOrHideDrawView:YES];
            [self showAutoHiddenAlert:title];
            [self.drawMenuView removeFromSuperview];
            self.drawMenuView = nil;
        }
    }
    if ([CCDocManager sharedManager].videoSuspend)
    {
        [self videoSuspendShowOrHideDrawView:YES];
    }
    else
    {
        [self videoSuspendShowOrHideDrawView:NO];
    }
}

- (void)showAutoHiddenAlert:(NSString *)title
{
    if (_loadingView) {
        [_loadingView removeFromSuperview];
        _loadingView = nil;
    }
    _loadingView = [[LoadingView alloc] initWithLabel:title showActivity:NO];
    [self.view addSubview:_loadingView];
    [_loadingView mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.edges.mas_equalTo(UIEdgeInsetsMake(0, 0, 0, 0));
    }];
    [self performSelector:@selector(alertViewAutoHide:) withObject:_loadingView afterDelay:2];
}

- (void)alertViewAutoHide:(LoadingView *)alertView
{
    [alertView removeFromSuperview];
}

- (void)videoSuspendShowOrHideDrawView:(BOOL)show
{
    if (self.drawMenuView)
    {
        self.drawMenuView.hidden = show;
    }
}

#pragma mark -- 计时器添加
- (UIView *)timerView
{
    if (!_timerView)
    {
        _timerView = [UIView new];
        _timerView.backgroundColor = CCRGBAColor(0, 0, 0, 0.3);
        _timerView.layer.cornerRadius = CCGetRealFromPt(70) / 2;
        _timerView.layer.masksToBounds = YES;
        
        UIImageView *backImageView = [[UIImageView alloc] init];
        UIImage *image = [UIImage imageNamed:@"setting"];
        image = [image stretchableImageWithLeftCapWidth:image.size.width/2.f topCapHeight:image.size.height/2.f];
        backImageView.image = image;
        [_timerView addSubview:backImageView];
        WS(ws);
        [backImageView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.edges.mas_equalTo(ws.timerView);
        }];
        
        UIImageView *imageView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"clock2"]];
        [_timerView addSubview:imageView];
        [imageView mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(ws.timerView).offset(infomationViewClassRoomIconLeft);
            make.centerY.mas_equalTo(ws.timerView);
            make.height.mas_equalTo(ws.timerView).offset(-6.f);
            make.width.mas_equalTo(imageView.mas_height);
        }];
        
        [_timerView addSubview:self.timerLabel];
        [_timerLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(imageView.mas_right).offset(infomationViewHostNamelabelLeft);
            make.centerY.mas_equalTo(ws.timerView).offset(0.f);
            //            make.size.mas_equalTo(ws.timerLabel.frame.size);
        }];
    }
    return _timerView;
}

- (UILabel *)timerLabel
{
    if (!_timerLabel)
    {
        _timerLabel = [UILabel new];
        _timerLabel.font = [UIFont systemFontOfSize:FontSizeClass_12];
        _timerLabel.textAlignment = NSTextAlignmentLeft;
        _timerLabel.textColor = CCRGBColor(249, 57, 48);
        _timerLabel.text = @"00:00";
        [_timerLabel sizeToFit];
    }
    return _timerLabel;
}

- (void)updateTime
{
    NSTimeInterval end = [[CCStreamer sharedStreamer] getRoomInfo].timerStart + [[CCStreamer sharedStreamer] getRoomInfo].timerDuration;
    NSTimeInterval now = [[NSDate date] timeIntervalSince1970];
    NSTimeInterval left = end - now*1000;
    if (left > 0)
    {
        self.timerLabel.text = [CCTool timerStringForTime:left];
    }
    else
    {
        //开始动画
        if (self.timerTimer)
        {
            [self.timerTimer invalidate];
            self.timerTimer = nil;
        }
        self.timerLabel.textColor = CCRGBColor(249, 57, 48);
        CCWeakProxy *weakProxy = [CCWeakProxy proxyWithTarget:self];
        self.timerTimer = [NSTimer scheduledTimerWithTimeInterval:1.f target:weakProxy selector:@selector(animation) userInfo:nil repeats:YES];
    }
}

- (void)animation
{
    WS(ws);
    [UIView animateWithDuration:0.99f animations:^{
        ws.timerLabel.alpha = 0.0;
        //        ws.timerLabel.transform = CGAffineTransformMakeScale(0.8, 0.8);
    } completion:^(BOOL finished) {
        ws.timerLabel.alpha = 1.f;
        ws.timerLabel.transform = CGAffineTransformIdentity;
    }];
}

#pragma mark -- timer start
- (void)timerStart
{
    NSLog(@"%d", __LINE__);
    //计时器开始
    self.timerView.hidden = NO;
    WS(ws);
    CGSize userNameSize = [CCTool getTitleSizeByFont:self.timerLabel.text font:[UIFont systemFontOfSize:FontSizeClass_12]];
    [self.timerView mas_remakeConstraints:^(MASConstraintMaker *make) {
        //            make.centerX.mas_equalTo(ws.view).offset(0.f);
        make.left.mas_equalTo(ws.view).offset(10.f);
        make.top.mas_equalTo(ws.view).offset(CCGetRealFromPt(60));
        make.height.mas_equalTo(35);
        make.width.mas_equalTo(60+userNameSize.width);
    }];
    
    //        self.timerLabel.textColor = CCRGBColor(249, 57, 48);
    self.timerLabel.textColor = [UIColor whiteColor];
    NSTimeInterval end = [[CCStreamer sharedStreamer] getRoomInfo].timerStart + [[CCStreamer sharedStreamer] getRoomInfo].timerDuration;
    NSTimeInterval now = [[NSDate date] timeIntervalSince1970];
    NSTimeInterval left = end - now*1000;
    self.timerLabel.text = [CCTool timerStringForTime:left];
    if (self.timerTimer)
    {
        [self.timerTimer invalidate];
        self.timerTimer = nil;
    }
    CCWeakProxy *weakProxy = [CCWeakProxy proxyWithTarget:self];
    self.timerTimer = [NSTimer scheduledTimerWithTimeInterval:1.f target:weakProxy selector:@selector(updateTime) userInfo:nil repeats:YES];
}

- (void)timerEnd
{
    NSLog(@"%d", __LINE__);
    //计时器结束
    self.timerView.hidden = YES;
    WS(ws);
    [self.timerView mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(ws.view).offset(0.f);
        make.top.mas_equalTo(ws.view).offset(CCGetRealFromPt(60));
        make.height.mas_equalTo(1);
        make.width.mas_equalTo(1);
    }];
    
    if (self.timerTimer)
    {
        [self.timerTimer invalidate];
        self.timerTimer = nil;
    }
}

/** 计时器 */
- (void)startTimeTimer
{
    [self timerStart];
}
- (void)stopTimeTimer
{
    [self timerEnd];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    BOOL open = [[CCDocManager sharedManager]isTimerStart];
    if (open)
    {
        [self startTimeTimer];
    }
    else
    {
        [self stopTimeTimer];
    }
}

@end
