//
//  InputTextField.m
//  NewCCDemo
//
//  Created by cc on 2016/12/6.
//  Copyright © 2016年 cc. All rights reserved.
//

#import "CustomTextField.h"

@interface CustomTextField()


@end

@implementation CustomTextField

-(instancetype)init {
    self = [super init];
    if(self) {
        self.borderStyle = UITextBorderStyleNone;
        self.backgroundColor = CCRGBAColor(255,255,255,0.70);
        self.placeholder = @"请输入文字";
        
        self.font = [UIFont systemFontOfSize:FontSizeClass_15];
        self.textColor = CCRGBColor(51, 51, 51);
        self.clearButtonMode = UITextFieldViewModeNever;
        self.autocorrectionType = UITextAutocorrectionTypeDefault;
        self.clearsOnBeginEditing = NO;
        self.textAlignment = NSTextAlignmentLeft;
        self.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
        self.keyboardType = UIKeyboardTypeDefault;
        self.autocapitalizationType = UITextAutocapitalizationTypeNone;
        self.returnKeyType = UIReturnKeyDefault;
        self.keyboardAppearance = UIKeyboardAppearanceDefault;
        self.leftViewMode = UITextFieldViewModeNever;
        self.rightViewMode = UITextFieldViewModeAlways;
        self.layer.cornerRadius = CCGetRealFromPt(4);
        self.layer.masksToBounds = YES;
        self.layer.borderColor = [CCRGBAColor(230,230,230,1) CGColor];
        self.layer.borderWidth = 1;
        self.rightView = self.rightView;
    }
    return self;
}

-(CGRect)placeholderRectForBounds:(CGRect)bounds
{
    CGRect inset = CGRectMake(bounds.origin.x + CCGetRealFromPt(20) , bounds.origin.y + (bounds.size.height - [UIFont systemFontOfSize:FontSizeClass_13].lineHeight) / 2, bounds.size.width - CCGetRealFromPt(20), bounds.size.height);
    return inset;
}

- (CGRect)rightViewRectForBounds:(CGRect)bounds {
    CGRect inset = CGRectMake(bounds.size.width - CCGetRealFromPt(15) - CCGetRealFromPt(48) , bounds.origin.y, CCGetRealFromPt(48), bounds.size.height);
    return inset;
}

//控制placeHolder的颜色、字体
- (void)drawPlaceholderInRect:(CGRect)rect
{
    NSMutableParagraphStyle *style = [self.defaultTextAttributes[NSParagraphStyleAttributeName] mutableCopy];
    
    style.minimumLineHeight = self.font.lineHeight - (self.font.lineHeight - [UIFont systemFontOfSize:FontSizeClass_13].lineHeight) / 2.0;
    
    NSDictionary *dict = @{NSFontAttributeName:[UIFont systemFontOfSize:FontSizeClass_13],NSForegroundColorAttributeName:CCRGBColor(180,180,180),NSParagraphStyleAttributeName:style};
    
    [self.placeholder drawInRect:rect withAttributes:dict];
}

// 重写来编辑区域，可以改变光标起始位置，以及光标最右到什么地方，placeHolder的位置也会改变
-(CGRect)editingRectForBounds:(CGRect)bounds
{
    if (self.rightView)
    {
        CGRect inset = CGRectMake(bounds.origin.x+CCGetRealFromPt(20), bounds.origin.y, bounds.size.width-CCGetRealFromPt(20) * 2 - CCGetRealFromPt(15) - CCGetRealFromPt(48), bounds.size.height);//更好理解些
        return inset;
    }
    else
    {
        CGRect inset = CGRectMake(bounds.origin.x+CCGetRealFromPt(20), bounds.origin.y, bounds.size.width-CCGetRealFromPt(20) * 2 - CCGetRealFromPt(15), bounds.size.height);//更好理解些
        return inset;
    }
}

@end
